/** Klasa dla obiektow, ktore nie sa MeshObject'ami, bo nie potrzeba
 * (w grze sie nie renderuja - musza byc widoczne tylko w edytorze).
 */
public class EditorRenderableObject extends ControlObject
{
	/**Nazwa pliku zawierajacego dane obiektu 3da, ktory ma 
	 * reprezentowac obiekt, jesli tak jest ustawiony tryb wyswietlania*/
	public String EditorMeshName = "";	
	
	/** Okresla skad mamy brac mesh'a, ktory bedzie wyswietlany. Wartosc
	 * EEditorRenderType._MESH oznacza, ze mamy wziasc na podstawie MeshName.
	 * Dla pozostalych wartosci bierzemy z listy odczytanych z pliku "EditorMeshes.ini"
	 */
	public int iRenderType = EEditorRenderType._MESH;
	
	/** Wolane w celu okreslenia jaka powinna byc macierz obiektu na
	 * podstawie jego danych; 
	 * @return true jesli wprowadzona zostala jakas zmiana
	 */
	public boolean UpdateMatrixByData(){ return false;}
	
	/** Procka dzialajaca przeciwnie do UpdateMatrixByData() - wolana
	 * w momencie zmiany macierzy obiektu w edytorze (a przynajmniej tam).
	 * Do modyfikacji danych obiektu na podstawie jego aktualnej macierzy.
	 * @return true jesli wprowadzona zostala jakas zmiana
	 */
	public boolean UpdateDataByMatrix(){ return false;}
    
    /*
    public void OnCreate()
    {
        // wylaczamy updejtowanie obiektow tego typu
        ClearFlag(EFlags._NOT_STATIC);
    }
    */
}
