
/** Flagi trybu filtrowania
 * Uwaga: Definicje musza byc zgodne z definicjami w TexManager.hpp
 */

public class EFilteringModes
{
    final static int NO_FILTERING         = 0x01;
    final static int BILINEAR_NO_MIPMAPS  = 0x02;
    final static int BILINEAR             = 0x80;
    final static int TRILINEAR            = 0x81;
    final static int ANISOTROPIC          = 0x82;
    final static int ANISOTROPIC_TRILINEAR= 0x83;
    
    static String GetFlagName(int nFlag)
    {
        String sRet = "__UNKNOWN FLAG____";
        switch (nFlag)
        {
            case NO_FILTERING:
                sRet = "NO_FILTERING";
                break;
            case BILINEAR_NO_MIPMAPS:
                sRet = "BILINEAR_NO_MIPMAPS";
                break;
            case BILINEAR:
                sRet = "BILINEAR";
                break;
            case TRILINEAR:
                sRet = "TRILINEAR";
                break;
            case ANISOTROPIC:
                sRet = "ANISOTROPIC";
                break;
            case ANISOTROPIC_TRILINEAR:
                sRet = "ANISOTROPIC_TRILINEAR";
                break;
        }
        return sRet;
    }
}
