
/** Flagi trybu cieni dynamicznych
 * Uwaga: Definicje musza byc zgodne z definicjami w VideoSettings.h
 */

public class EShadowModes
{
    final static int NONE         = 0;
    final static int BLOBS        = 1;
    final static int SHADOWMAPS   = 2;
    
    static String GetFlagName(int nFlag)
    {
        String sRet = "__UNKNOWN FLAG____";
        switch (nFlag)
        {
            case NONE:
                sRet = "NONE";
                break;
            case BLOBS:
                sRet = "BLOBS";
                break;
            case SHADOWMAPS:
                sRet = "SHADOWMAPS";
                break;
        }
        return sRet;
    }

}
