public class UIControlObject extends UIStatic
{
    boolean m_bProcessCommand = true;
    boolean m_bProcessNotify = true;	
	boolean m_bCanFocus = false;
	boolean m_bFocus=false;
    
	
    UITexture m_cFocusTexture = null;
    float m_fFocusTextureAlpha = 1.0f;
    
    float m_fFocusTextAlpha = 1.0f;
    
	// kolor
	Vector  m_vHighLigthTxtColor =null;	
	/**wekotor wzorcow */	
    java.util.Vector m_vPatterns = null;
	/** muzyka 	 */
	String m_sFocusSound = null;
    boolean m_bPlayFocusSound = false; // jesli true to ustawienie focusa  odtworzy dzwiek	
	/** ----------------------------------------------------- 
	 *  Zarzadzanie elementami podrzednymi, ktore sa traktowane w 
	 * aktualnym elemencie jako logiczna calosc 
	 */
	   java.util.Vector m_vMembers = null;
	   int m_nFocusSelectorUp = EKey._UP;
       int m_nFocusSelectorDown = EKey._DOWN; 		

	   UIControlObject m_cCurrMember=null;
	   boolean m_bWrap = true;
       
	   // znacznik, informujacy, ze wlasnie sciaga focusa starego
	   // i sterowanie jest zablokowane
	   boolean m_bSearchingOldFocus=false;
	/**------------------------------------------------------- */
	   
    void OnCreate()
	{
	   m_vMembers = new java.util.Vector();
//	   LogLine("Ctl:onCreate:members"+ m_vMembers);
       m_vPatterns = new java.util.Vector();	   
	   super.OnCreate();	
	}
    
	/**  aktywuje/deaktywuje okno oraz jego wszystkie dzieci*/
	void SetActive(boolean bActive)
	{
        super.SetActive(bActive);
		UIWindow wnd;
/*		int cnt = m_vPatterns.size();
		for(int i = 0; i < cnt; i++)
		{
			wnd = (UIWindow)m_vPatterns.elementAt(i);	   
			wnd.SetActive(bActive);
		}*/
	}	
    //=================== STEROWANIE ODSWIEZANIEM 	   	
	/** odswiezanie ctl-a     */	
	public void OnFrame()
	{
		if( !m_bInited )
			return;		
		super.OnFrame();
		
	}	
    
	public void Reload()
	{
	   super.Reload();
       UpdateFocus();
	}
    
    void UpdateFocus()
    {
        OnFocusDisplay();
		OnFocusSound();
		OnFocusControl();
    }
    
	public void OnFocusDisplay()
	{
		// pokazanie focusa
	    if(m_bFocus)
	    {
           if(m_cFocusTexture!=null)
               SetTexture(m_cFocusTexture);
           SetTextAlpha(m_fFocusTextAlpha);
		   if(m_vHighLigthTxtColor!=null)
		   {
     	      SetTextColor(m_vHighLigthTxtColor.fX, m_vHighLigthTxtColor.fY, m_vHighLigthTxtColor.fZ, m_fCurTextAlpha);  
		   }
           SetAlpha(m_fFocusTextureAlpha);
           //SetTextAlpha(m_fFocusTextAlpha);
           
	    }
        
		// ukrycie focusa
	    if(!m_bFocus)
	    {
            SetTextAlpha(m_fTextAlpha);            
            SetTextColor(m_vTextColor.fX, m_vTextColor.fY, m_vTextColor.fZ, m_fCurTextAlpha);  
            OnTextureChange();
            SetAlpha(m_fTextureAlpha);
		}
	}
    
    public void SetTextAllColors(float r, float g, float b)
    {
        super.SetTextAllColors(r, g, b);
        if (m_vHighLigthTxtColor != null)
            m_vHighLigthTxtColor.Set(r, g, b);
        
    }
    
    public void SetTextAllAlpha(float fAlpha)
    {
        super.SetTextAllAlpha(fAlpha);
        m_fFocusTextAlpha = fAlpha;
    }
    
	public void OnFocusSound()
	{
	    if(m_bFocus)
   		   if(m_sFocusSound!=null)
               if (m_bPlayFocusSound)
		            PlaySound(m_sFocusSound);
	}
    
	public void OnFocusControl()	
	{
	    // ustawienie focusa wsrod dzieci
        if(m_bFocus)
        {
            // ustawienie focusa dla elementow podrzednych
            //powiadomienie elementu nadrzednego
            if(m_cSupervisor!=null && m_cSupervisor!=this)
                Notify(this, EUIConst.EV_FOCUS);
            
            if(m_cCurrMember==null)	
            {
                UIControlObject ctl=GetNext(-1);
                if(ctl!=null)
                    ctl.SetFocus(true); 
            }
            else
            {
                if(!m_cCurrMember.m_bFocus)
                    m_cCurrMember.SetFocus(true);
            }
        }
        if(!m_bFocus)
        {
            if(m_cSupervisor!=null && m_cSupervisor!=this)
                Notify(this, EUIConst.EV_FOCUSOFF);						  
            
            if(m_cCurrMember!=null)	
            {
                m_cCurrMember.SetFocus(false);
                m_cCurrMember = null;
            }
        }		
	}
	
	public void OnInit()
	{
		super.OnInit();

	}	
    
    /** ustwia alfe dla textury z focusem */
    void SetFocusTextureAlpha(float fTextureAlpha)
    {
        m_fFocusTextureAlpha = fTextureAlpha;
    }
    /** ustwia alfe dla textury z focusem */
    void SetFocusTextAlpha(float fTextAlpha)
    {
        m_fFocusTextAlpha = fTextAlpha;
    }        
	
	/** dodanie wzorca do wektora*/
	void AddPattern(UIWindow cWnd)
	{
        //CrashLog(this + " ADDING PATTERN " + cWnd);
		cWnd.m_bActive = false;
		m_vPatterns.addElement((Object)cWnd);
		GetModule().AddSprite(cWnd);
		//cWnd.ActivateOnModule();
		cWnd.OnInit();
	}
	void RemovePattern(UIWindow cWnd)
	{
		m_vPatterns.removeElement(cWnd);
	}
	/** pobranie wzorca sName dla elementu typu nType
	 */
	UIWindow GetPattern(String sType)
	{
		UIWindow cWnd=null;
	    for(int i=0;i<m_vPatterns.size();i++)
		{
			cWnd = (UIWindow)(m_vPatterns.elementAt(i));
			// jasli w m_sId zgadza sie typ elementu oraz
			// jest to okno lub m_sText odpowiada nazwie wolanego wzorca
			if( cWnd.m_sId.equals(sType))
			    return cWnd;  
		}
        if (m_cSupervisor != null && m_cSupervisor != this)
            return m_cSupervisor.GetPattern(sType);
        else
            return null;
	}
	
    UIWindow GetPatternLocal(String sType)
    {
        UIWindow cWnd=null;
	    for(int i=0;i<m_vPatterns.size();i++)
		{
			cWnd = (UIWindow)(m_vPatterns.elementAt(i));
			// jasli w m_sId zgadza sie typ elementu oraz
			// jest to okno lub m_sText odpowiada nazwie wolanego wzorca
			if( cWnd.m_sId.equals(sType))
			    return cWnd;  
		}
        return null;
    }
    
    boolean Load(ParseKeyword key)
	{
		ParseKeyword  paramKey;
		for(paramKey=key.GetChild(); paramKey!=null; paramKey=paramKey.GetNext())
		{
		  
		  if(paramKey.Equals("Command"))
		  {
		     if(paramKey.GetIParam(0) == 1 )
			     m_bProcessCommand = true;
			 else
			    m_bProcessCommand = false;
			 /*if(m_bProcessCommand )
			   LogLine("Command True");
  		     else
 			   LogLine("Command False");*/
		  }
		  if(paramKey.Equals("Notify"))		  
		  {
  		     if(paramKey.GetIParam(0) == 1 )
				 m_bProcessNotify = true; 
             else					 
				 m_bProcessNotify = false;
			 /*if(m_bProcessNotify)
			   LogLine("Notify TrUE");
  		     else
 			   LogLine("Notify FALSE");			 */
		  }
          if(paramKey.Equals("CanFocus"))		  
		  {
  		     if(paramKey.GetIParam(0) == 1 )
			 {
				 m_bCanFocus = true; 
				 ProcessKb(true);
				 //LogLine("PROCEEEEEEEEEEEES_kb");
			 }
             else					 
				 m_bCanFocus = false;		  
		  }
		  if(paramKey.Equals("TextureHightlight"))						 
			{	
  //              LogLine("TEXTUUUUREW  "+paramKey.GetSParam(0)+ "  "+this);
				m_cFocusTexture = new UITexture(this);
				m_cFocusTexture.m_sFileName = paramKey.GetSParam(0);
				m_cFocusTexture.m_rRect = null;
				LoadTexture(m_cFocusTexture);				
			}
            if(paramKey.Equals("TextureFocusAlpha"))
            {
                SetFocusTextureAlpha(paramKey.GetFParam(0));   
            }
            if(paramKey.Equals("TextFocusAlpha"))
            {
                SetFocusTextAlpha(paramKey.GetFParam(0));   
            }                      
			if (paramKey.Equals("TextureHightlightRect"))  // tekstura wycieta 
            {
				m_cFocusTexture = new UITexture(this);
				m_cFocusTexture.m_sFileName = paramKey.GetSParam(0);
				m_cFocusTexture.SetRect(paramKey.GetFParam(1),
										 paramKey.GetFParam(2),
										 paramKey.GetFParam(3),
										 paramKey.GetFParam(4),
										 paramKey.GetFParam(5),
										 paramKey.GetFParam(6));										 
				LoadTexture(m_cFocusTexture);				
            }          

          if(paramKey.Equals("TextHighLightColor"))	
	      {
		       float r,g,b;
		       r = paramKey.GetFParam(0);
		       g = paramKey.GetFParam(1);
		       b = paramKey.GetFParam(2);
		       //LogLine("Kolor odznaczony: "+r+" "+g+" "+b);
 	         m_vHighLigthTxtColor = new Vector(r,g,b);		  
	      }		
	     if(paramKey.Equals("SelKeyUp"))						 
		 {			 
		   m_nFocusSelectorUp = paramKey.GetIParam(0);
		   //LogLine("Klawisz up : "+   m_nFocusSelectorUp);
		 }
	     if(paramKey.Equals("SelKeyDown"))						 
		 {			 
		   m_nFocusSelectorDown = paramKey.GetIParam(0);
		   //LogLine("Klawisz up : "+   m_nFocusSelectorDown);
		 }
	     if(paramKey.Equals("FocusSound"))						 
		 {			 
		   m_sFocusSound = paramKey.GetSParam(0);
		   //LogLine("Sound"+   m_sFocusSound);
		 }		 		 
		 
		}
        super.Load(key);			
		return true;
	}
  /** ustawianie Focusa     */
  void SetFocus(boolean bActive)	
  {
	 if(!m_bActive)
		return;
      // poprzedni stan focusa  
	 boolean bOldFocus = m_bFocus; 
	 // ustawienie focusa dla elementu
	 if(bActive && !bOldFocus)
	 {
	     m_bFocus=true; 				 
	     UpdateFocus();
	 }
	 if(!bActive && bOldFocus)
	 {
	     m_bFocus=false; 		
	     UpdateFocus();		
     }
    }	
  
   /** dodaje element potomny programowo   */
   void AddElement(UIWindow cWnd)
   {
            AddChild(cWnd);       
		    cWnd.m_cSupervisor=this;
			if(m_bEditStateOnInit)  // dzieciom nadaje swoje tekstury
			    cWnd.m_bEditStateOnInit = true;
			if(m_currCursor!=null)
            {
			   cWnd.m_currCursor = m_currCursor;			
               cWnd.m_sCursorTex = m_sCursorTex;
            }
			cWnd.AddToInterface(m_vMembers);       
            cWnd.OnInit();
   }
  /**   */
	void AddToInterface(java.util.Vector vElems)
	{
		//LogLine(""+this+" vElems: "+vElems);
		vElems.addElement((Object)this);
//		LogLine("ctl==========Metoda Ctl::AddToI w "+m_sId);
//		LogLine("ctl----------My m_bEditStateOnInit is "+m_bEditStateOnInit);		
		UIWindow wnd;
		int cnt = m_vChildWindows.size();
		for(int i = 0; i < cnt; i++)
		{
			wnd = (UIWindow)m_vChildWindows.elementAt(i);	   
	        //LogLine(""+this+" dodaje dziecko "+wnd); 			
//			LogLine("Ctl---------Child "+wnd.m_sId+" of "+m_sId);			
		    wnd.m_cSupervisor=this;
//			LogLine("State ON INIT Ctl ::: "+m_bEditStateOnInit+" u "+m_sId);			
			if(m_bEditStateOnInit)  // dzieciom nadaje swoje tekstury
			    wnd.m_bEditStateOnInit = true;
			if(m_currCursor!=null)
            {
			   wnd.m_currCursor = m_currCursor;			
               wnd.m_sCursorTex = m_sCursorTex;
            }
			wnd.AddToInterface(m_vMembers);
		}
		//ActivateOnModule();
		// wzorce, dodawane jako nieaktywne dzieci
		cnt = m_vPatterns.size();
		for(int i = 0; i < cnt; i++)		
		{
			wnd = (UIWindow)m_vPatterns.elementAt(i);	   
			SetPatternParam(wnd);
		}
	}
	void SetPatternParam(UIWindow cPattWnd)
	{
		   if(m_currCursor!=null)
           {
			        cPattWnd.m_currCursor = m_currCursor;
                    cPattWnd.m_sCursorTex = m_sCursorTex;
           }
			FixMemberEditParams(cPattWnd);
			cPattWnd.SetMembersEditState();		
	}
	/** Zwraca element podrzedny nInd
	 */
	UIWindow GetMember(int nInd)
	{
	   if(nInd>=m_vMembers.size() || nInd<0)
		   return null;
	   return (UIWindow)m_vMembers.elementAt(nInd);
	}
	
   UIWindow GetMemberByName(String sId)
   {	
        int nSize = m_vMembers.size();
		for(int i= 0; i<nSize; i++)
		{
  	       UIWindow wnd = (UIWindow)(m_vMembers.elementAt(i));
	       if((wnd.m_sId).equals(sId))
		   {
			   return wnd;
		   }
		}
		return null;
   }
		
     /** Znajdowanie elementu podrzednego, ktory ma ustawionego focusa
	 */	
    int FindFocus()
    {
       UIWindow wnd;
	   
	   if(m_cCurrMember==null)
		   return EUIConst.NO_DEFINED;
	   int nSize = m_vMembers.size();
	   for(int j=0; j<nSize ; j++)
	   {	
	  		wnd = (UIWindow)m_vMembers.elementAt(j);	   
			if(wnd == m_cCurrMember)
				return j;
	   }
	   return EUIConst.NO_DEFINED;
	}
    // sprawdza czy dany element podrzedny moze przyjac focusa 
	boolean CanFocus(UIWindow wnd)
	{
//	  LogLine("Can focus "+m_sId);	
        if(!m_bActive)
            return false;		
        if(wnd instanceof UIControlObject)
        {
            if(((UIControlObject)wnd).m_bCanFocus && 
               wnd.m_bActive &&
               wnd.IsActuallyVisible())
            {
                if(wnd instanceof UIButton)  //gdy buton nie wylaczony
                    return (!((UIButton)wnd).m_bDisabled);
                else					
                    return true;
            }
        }
        return false;
	}
    // znajduje nastepny mozliwy do focusa element podrzedny (w gore)	
    UIControlObject GetPrev(int nInd)
	{
        if(m_vMembers.size()==0)
            return null;		
        int nStart;
        if(nInd ==EUIConst.NO_DEFINED)
            nStart = 0;
        else
            nStart=nInd;
        
        UIWindow wnd;
        int nPoint=nStart-1;    
        while( nPoint>=0 || m_bWrap )
        { 
            if(nPoint<0)
                nPoint=m_vMembers.size()-1;			
            if(nPoint==nStart)
                break;
            wnd=(UIWindow)m_vMembers.elementAt(nPoint);	   
            if(CanFocus(wnd))
            {
                return (UIControlObject)wnd;	
            }
            else
                nPoint--;
        }
        return null;		
    }
    
    UIControlObject GetNext(int nInd)
    {
        if(m_vMembers.size()==0)
            return null;
        int nStart;
        int nPoint;
        boolean bFirstRound = false; // czy pierwszy przebieg przy niezdefiniowanym 
        // biezacym elemencie
        if(nInd ==EUIConst.NO_DEFINED)
        {
            nStart = 0;
            nPoint = 0;
            bFirstRound = true;
        }
        else
        {
            nStart=nInd;
            nPoint=nStart+1;
        }
        
        UIWindow wnd;
        
        if (m_vMembers.size() == 0)
            return null;
        
        while( nPoint < m_vMembers.size() || (m_bWrap) )
        { 
            if(nPoint >= m_vMembers.size())
                nPoint = 0;
            if(nPoint == nStart && !bFirstRound)
                break;
            if(bFirstRound)
                bFirstRound = false;
            
            wnd = (UIWindow)m_vMembers.elementAt(nPoint);	   
            
            if(CanFocus(wnd))
            {
                return (UIControlObject)wnd;	
            }
            else
                nPoint++;
            LogLine(this + " GetNext nPoint:"+nPoint +" nStart: "+nStart);
        }
        return null;
    }
    
    void OnKeyReleased(int nKey, char nAsci)
    {
        //        LogLine(" Wnd "+this + " Key : "+nKey +" focus "+m_bFocus + "\n");        
        if(!m_bActive)
            return;		
        
        if(m_bEditState)
        {
            super.OnKeyReleased(nKey,nAsci);
            return;
        }        
        if(!m_bFocus) 
            return;
        
        int  nOldFocus;  //indeks buttona z biezacycm focusem
        UIControlObject cCtlToFocus=null;
        if(m_nFocusSelectorUp !=EUIConst.NO_DEFINED && nKey == m_nFocusSelectorUp)
        {
            nOldFocus = FindFocus();	
            cCtlToFocus = GetPrev(nOldFocus);		   
            if(cCtlToFocus!=null)
            {
                cCtlToFocus.m_bPlayFocusSound = true; 
                cCtlToFocus.SetFocus(true);
            }
        }
        if(m_nFocusSelectorDown !=EUIConst.NO_DEFINED && nKey == m_nFocusSelectorDown)
        {
            nOldFocus = FindFocus();	
            cCtlToFocus = GetNext(nOldFocus);		   

            if(cCtlToFocus!=null)
            {
                cCtlToFocus.m_bPlayFocusSound = true; 
                cCtlToFocus.SetFocus(true);
            }
        }
    }
    
    // skroty do przesylania komunikatow
    void Command(UIWindow cSender, int nCommand)
    {
        if(!m_bActive)
            return;				
        if(m_bProcessCommand && (m_cSupervisor != null) && (m_cSupervisor != this))
            m_cSupervisor.CallOnUICommand(cSender, nCommand);		
    }
    
    void Notify(UIWindow cSender, int nEvent)		
    {
        if(!m_bActive)
            return;				
        if(m_bProcessNotify)		
            m_cSupervisor.CallOnUINotify(cSender, nEvent);		
    }

    void OnUICommand(UIWindow cSender, int nCommand)
    {
        if(!m_bActive)
            return;				
        Command(cSender, nCommand);
        //LogLine(m_sId+" : On_Command od "+cSender.m_sId);
    }
    void OnUINotify(UIWindow cSender, int nEvent)
    {
        if(!m_bActive)
            return;				
        //LogLine("Pre : OnNotify");
        if(cSender==this)  // komnikaty do siebie nie sa obslugiwane 
            return;        // przypadek interfejsu
        //LogLine(m_sId+" : On_Notify od "+cSender.m_sId+" e: "+nEvent);
        if(nEvent == EUIConst.EV_FOCUS)
        {
            if(m_cCurrMember !=cSender)  
            {
                if( m_cCurrMember!=null)
                    m_cCurrMember.SetFocus(false);
                m_cCurrMember = (UIControlObject)cSender;
                if(!m_bFocus)
                    SetFocus(true);

            }
            else
            {
                if(!m_bFocus)   
                    SetFocus(true);
            }
        }
	}  
	
	/** czy dane zostaly zmienione	(pokryta z UIWidnow) */
	boolean AreDataUpdated()
	{
        if(super.AreDataUpdated())
			return true;
 		//jesli nie
	    int cnt = m_vPatterns.size();
		for(int i = 0; i < cnt; i++)
		{
		   UIWindow wnd = (UIWindow)m_vPatterns.elementAt(i);	   
		   if(wnd.AreDataUpdated())
			   return true;
		}
		return false;
	}	
	/** anulowanie zaznaczenia ze dan zostaly zmienione	(pokryta z UIWidnow) */	
	void DismissDataUpdate()
	{
        super.DismissDataUpdate();
		int cnt = m_vPatterns.size();
		for(int i = 0; i < cnt; i++)
		{
		   UIWindow wnd = (UIWindow)m_vPatterns.elementAt(i);	   
		   wnd.DismissDataUpdate();
		}		
	}	
    
    void RemoveChild(UIWindow wnd)
    {
        super.RemoveChild(wnd);
        wnd.m_cSupervisor = null;
        m_vMembers.removeElement(wnd);
    }
    
    

	boolean SearchAndRemove(UIWindow cWndToDel)
	{
//		LogLine("SR(ctl): "+m_sId);
        boolean bDeleted = super.SearchAndRemove(cWndToDel);
		if(bDeleted)
			return true;
      	//Wzorce 

        for (int i = 0; i < m_vPatterns.size(); i++)
		{
			UIWindow wnd = (UIWindow)m_vPatterns.elementAt(i);	   		
			if(cWndToDel == wnd)
			{
			    wnd.Remove();
                RemovePattern(wnd);								
				wnd.GetModule().RemoveSprite(wnd);
		        wnd.delete();			
                wnd = null;							
				cWndToDel = null;
				return true;
			}
			else
			{
				bDeleted =  wnd.SearchAndRemove(cWndToDel);
				if(bDeleted)
					return true;
			}
		}
		return false;
	}

	void Remove()
	{
        while(m_vPatterns.size()>0)
		{		
			UIWindow wnd = (UIWindow)m_vPatterns.elementAt(0);	   				
			wnd.Remove();
            RemovePattern(wnd);											
			wnd.GetModule().RemoveSprite(wnd);			
		    wnd.delete();			
            wnd = null;		
		}
        m_vMembers.removeAllElements();
		super.Remove();
	}
    
     //zwolnienie tekstury z focusem lub normalnej
	void ReleaseTexture(UITexture cTex)
	{
        //rozpoznanie ktora to tekstura
        if(cTex == m_cFocusTexture)
            m_cFocusTexture = null;  // zerowanie zwyklej tekstury
        super.ReleaseTexture(cTex);
    }
    public void ReleaseTextures()
	{
	   super.ReleaseTextures();
	
       ReleaseTexture(m_cFocusTexture);
	}
	void Copy(UIWindow cWndDest, UIWindow cWndSrc)
	{
      UIControlObject cDest = (UIControlObject)cWndDest;
	  UIControlObject cSrc = (UIControlObject)cWndSrc;
	  
	  super.Copy(cDest,cSrc);
      m_bProcessCommand = cSrc.m_bProcessCommand;
      cDest.m_bProcessNotify = cSrc.m_bProcessNotify;	
	  cDest.m_bCanFocus = cSrc.m_bCanFocus;
	  cDest.m_bFocus = cSrc.m_bFocus;
	  
	  cDest.m_nFocusSelectorUp = cSrc.m_nFocusSelectorUp;
	  cDest.m_nFocusSelectorDown = cSrc.m_nFocusSelectorDown;	  
	  
	  cDest.m_bWrap=cSrc.m_bWrap;

	  if(cSrc.m_cFocusTexture !=null)
	  {
			cDest.m_cFocusTexture = new UITexture(this);
			cDest.m_cFocusTexture.CopyTexture(cSrc.m_cFocusTexture);
	  }
	  else
          cDest.m_cFocusTexture=null;
      
      cDest.SetFocusTextureAlpha(cSrc.m_fFocusTextureAlpha);
      cDest.SetFocusTextAlpha(cSrc.m_fFocusTextAlpha);
      
      cDest.m_sFocusSound = cSrc.m_sFocusSound;


	  if(cSrc.m_vHighLigthTxtColor!=null)	  
	      cDest.m_vHighLigthTxtColor = new Vector(cSrc.m_vHighLigthTxtColor); 
	  else
          cDest.m_vHighLigthTxtColor=null;
	  
		// kopiowanie wzorcow
		int cnt = cSrc.m_vPatterns.size();
		for(int i = 0; i < cnt; i++)
		{
			UIWindow cSrcChild = (UIWindow)(cSrc.m_vPatterns).elementAt(i);	   
			UIWindow cWndNew = (UIWindow)CreateObject(cSrcChild.m_sClassName);
			cWndNew.m_sClassName = cSrcChild.m_sClassName;
			cWndNew.m_sId = cSrcChild.m_sId;
			cSrcChild.Copy(cWndNew,cSrcChild);
            cDest.AddPattern(cWndNew);		  
		}	  
   }
	  
}
