public class MediaList
{
	
   //KONSTRUKTORY 
	 MediaList()
	 {
	 	  m_objects = new java.util.Vector(); 
	 }
	//INTERFEJS

	/** Dodaje obiekt medialny*/
	public void AddObject(MediaObject object)
	{
	       	m_objects.addElement(object);
	}
	
	/** Zwraca obiekt medialny nIndex*/
	public MediaObject GetObject(int nIndex)
	{
	   return (MediaObject)m_objects.elementAt(nIndex);	
	}
	/** Zwraca liczbe obiektow medialnych na liscie*/
	public int GetSize()
	{
	  return m_objects.size();	
	}
	 
	/** Zwraca obiekt , ktory najlepiej pasuje do kontekstu currContext.
	 * Jesli zaden obiekt z listy nie pausuje to zwraca NULL	*/
	public MediaObject FindBest(Context currContext)
	{
    int nIndMax=0;  // indeks obietu ktory najlepiej pasuje do kontekstu
		int nValueMax=-1; // najlepsze dopasowanie
		int nTmp;
		int nSize = m_objects.size();
		MediaObject object;
		
		for(int i=0; i<nSize;i++)
		{
			object=(MediaObject)m_objects.elementAt(i);
			nTmp=object.CheckContext(currContext);
			if(nValueMax<nTmp)
			{
				nValueMax=nTmp;
				nIndMax=i;
			}	
		}
        if(nValueMax == -1)
		    return null;
		else
			return (MediaObject)m_objects.elementAt(nIndMax);
	}
	/** Zwraca dopasowanie obiektu medialnego nIndex do kontekstu */
	public int GetMatching(int nIndex, Context currContext)
	{
	   return (this.GetObject(nIndex)).CheckContext(currContext);
	}
	
	/** wyswietla sie w logu	 */
	void Show()
	{
		if(m_objects==null)
		{
			GameObject.LogLine("   - null ");
			return;
		}
		for(int i=0;i<m_objects.size();i++)
		{
   		   	MediaObject cBuffer = (MediaObject)m_objects.elementAt(i);			
			GameObject.LogLine("       - "+cBuffer.m_sName+ "  Context: ");
			cBuffer.m_pattContext.Show();
		}
	}	
	
    //DANE
	protected java.util.Vector m_objects;
    
    void delete()
    {
        if (m_objects != null)
        {   
            for (int i = 0; i < m_objects.size(); i++)
                ((MediaObject)m_objects.elementAt(i)).delete();
            m_objects.removeAllElements();
            m_objects = null;
        }
        
    }
}
