/** klasa reprezentujaca obiekt mult. - animacje lub dzwiek
 */
public class MediaObject
{
   // PUBLICZNE	
	/** nazwa obiektu multimedialnego
	 */
	String m_sName;  
	
	//KONSTRUKTORY 
	MediaObject(String sName)
	{
		 m_sName = sName;
	}
		
	//INTERFEJS
	/** Zwraca nazwe obiektu	 */
	public String GetName()
	{
	  return m_sName;	
	}

	public void SetPattContext(Context context)
	{
		int nSize= context.GetDimension();
		m_pattContext = new Context(nSize);

		for(int i=0;i<nSize;i++)
			m_pattContext.SetValue(i, context.GetValue(i));
	}
	/** Sprawdza czy zadany kontekst pasuje do wzorca kontekstu dolaczonego do 
	 * animacji, zwraca liczbe elementow kontekstu ktore bezposrednio pasuja do 
	 * wzorca (konkretna wartosc we wzorcu a nie _ANY), 
	 * zwraca -1 jesli zadany kontekst nie pasuje do wzorca
	 */
	public int CheckContext(Context context)
	{
	   	int nCount=0; // licznik bezporednich dopasowan
		int nSize=context.GetDimension();
		String sValueContext, sValuePattern;
		for(int i=0;i<nSize;i++)
		{  
		   sValueContext= context.GetValue(i);
		   sValuePattern= m_pattContext.GetValue(i);
		   if(sValuePattern.equals(EAnimal._ANY))
			   continue;
		   if(sValuePattern.equals(EAnimal._NO_DEFINED))
			   if(!(sValueContext.equals(EAnimal._NO_DEFINED)))
			   {
				  nCount= -1;
				  break;
			   }
			  else
			    continue;
		   if(sValuePattern.equals(sValueContext))
			   nCount++;
    	   else
  		   {
			  nCount= -1;
			  break;
		   }
		}
		return nCount;	  
	}
	/** zwraca kontext
	 	 */
	public Context GetContext()
	{
		return m_pattContext;
	}
	
	
	//DANE
	/** wzorzec kontekstu dolaczony do animacji 
	 */
	Context m_pattContext=null;
    
    void delete()
    {
        if (m_pattContext != null)
            m_pattContext.delete();
        m_pattContext = null;
    }
}
