public class EButtonFlags
{
    final static int BTN_TYPE_MASK         = 0x00FF;
    /**Zwykly przycisk, ktory mozna wciskac.*/
    final static int BTN_TYPE_PUSHBUTTON   = 0x0001;
    /**Przycisk ktory moze byc zaznaczony lub odznaczony*/
    final static int BTN_TYPE_CHECKBUTTON  = 0x0002;
    /**Lista z przewijakiem*/
    final static int BTN_TYPE_LISTBOX      = 0x0004;
    /**Element listy*/
    final static int BTN_TYPE_LISTBOX_ITEM = 0x0008;
    /**Przycisk, ktory po wcisnieciu i przytrzymaniu wysyla kolejne
     * wiadomosci o wcisnieciu.*/
    final static int BTN_TYPE_PRESSBUTTON  = 0x0040;
    /**ProgressBar dyskretny (kropy)*/
    final static int WND_TYPE_PROGRESS_BAR_DISCRETE = 0x0010;
    /**ProgressBar ciagly (kreska)*/
    final static int WND_TYPE_PROGRESS_BAR = 0x0020;
    /**Edit box*/
    final static int WND_TYPE_EDIT         = BTN_TYPE_CHECKBUTTON;
    
    final static int BTN_STATE_MASK        = 0xFF00;
    
    /**Przycisk jest aktualnie wycisniety/odznaczony.*/
    final static int BTN_STATE_UNCHECKED    = 0x0100;
    /**Przycisk jest aktualnie wcisniety/zaznaczony.*/
    final static int BTN_STATE_CHECKED      = 0x0200;
    /**Kliknieto lewym przyciskiem myszy nad przyciskiem i jeszcze nie
     * puszczono - zmiana stanu przycisku nastapi po puszczeniu klawisza
     * myszy nad przyciskiem*/
    final static int BTN_STATE_PUSHED       = 0x0400;
    /**Przycisk nieaktywny (wyszarzony)*/
    final static int BTN_STATE_DISABLED           = 0x0800;
    /**Przycisk podswietlony*/
    final static int BTN_STATE_HIGHLIGHTED        = 0x1000;
    
    /*static String GetFlagName(int nFlag)
    {
        String sRet = "__UNKNOWN FLAG____";
        switch (nFlag)
        {
            case :
                sRet = "";
                break;
            case :
                sRet = "";
                break;
            case :
                sRet = "";
                break;
            case :
                sRet = "";
                break;
            case :
                sRet = "";
                break;
            case :
                sRet = "";
                break;
            case :
                sRet = "";
                break;
            case :
                sRet = "";
                break;
            case :
                sRet = "";
                break;
            case :
                sRet = "";
                break;    
        }
        return sRet;
    }*/
    
}
