/** Sposoby reakcji bryly sztywnej w momencie kolizji.
    IGNORE - powoduje zignorowanie kolizji - czyli bryla przenika przez przeszkode.
    BOUNCE - powoduje odbicie sie od przeszkody.
    UWAGA: wartosci musza byc zgodne z enumem RigidBodyCollisionConstraints::ECollisionResponse 
    zdefiniowanym w pliku "RigidBodyCollisionConstraints.hpp".
*/
public class ECollisionResponse
{
    final static int IGNORE     =   0;          
    final static int BOUNCE     =   1;

    static String GetFlagName( int nFlag )
    {
        switch( nFlag )
        {
            case IGNORE:
                return "IGNORE";
            case BOUNCE:
                return "BOUNCE";
            default:
                return "__UNKNOWN RESPONSE____";
        }
    }
}

