/** Flagi takie same jak w surface.def
 * Uzywane bezposrednio przez TraceObjectsWithFaceFlags
 */
public class EFaceFlags
{
    final static int NO_FLAGS             = 0x0000;

    /* face'y z ta flaga nie koliduja z promieniem */
    final static int NO_BLOCK_RAY         = 0x0001;
    
    /* face'y z ta flaga nie koliduja z elipsoidami */
    final static int NO_BLOCK_MOVE        = 0x0002;
    
    /* ponizsze flagi maja znaczenie tylko dla funkcji TraceObjectsWithFaceFlags */
    
    /* flaga uzywana do zaznaczania face'ow przez ktore AI widzi i moze strzelac */
    final static int SEE_THROUGH          = 0x0004;

    /* flaga uzywana do zaznaczania face'ow przez ktore mozna (czasem) strzelac (np. siatki) */
    final static int SHOOT_THROUGH        = 0x0008;
}
