public class ComboBoxList extends ListBox 
{
    ComboBox Owner;
    void OnLBDownOut(float fMouseX, float fMouseY)
    {
	    //LogLine("fMouseX = " + fMouseX + " fMouseY" + fMouseY);
        if (Owner != null ) Owner.ExitList();
		/*if(bListIsActive)
	    {
		    Vector vSPos = new Vector(List_Item.GetPos());
			Vector vSSize = new Vector(List_Item.GetSize());
			if ( fMouseX < vSPos.fX && fMouseY < vSPos.fY )
			{
				ExitList();
				return;
			}
			else
			{
			    vSPos.Add(vSSize);
				if ( fMouseX > vSPos.fX && fMouseY > vSPos.fY )
				{
				    ExitList();
					return;
				}
			}
		}*/
	}
    void OnRBDownOut(float fMouseX, float fMouseY)
    {
	    //LogLine("fMouseX = " + fMouseX + " fMouseY" + fMouseY);
        if (Owner != null ) Owner.ExitList();
    }
    
    void CreateScrollBar()
    {
        btnUpArrow = (Button) this.CreateObject("Button");
        AddChild(btnUpArrow);
        AddChildWnd(btnUpArrow, wndRoot);
        btnUpArrow.Init(new UIElement(EUI.ID_SCROLL_UP,0,
                                    new Vector(0,0,0),
                                    new Vector(32,16,0),
                                    "Data/Menu/ramka_roz_gora.png",
                                    "Data/Menu/ramka2_roz_gora.png",
                                    "Data/Menu/ramka_roz_gora.png",
                                    "Data/Menu/ramka2_roz_gora.png",
                                    EButtonFlags.BTN_TYPE_PRESSBUTTON,
                                    ""),
                      module);
                
        btnDnArrow = (Button) this.CreateObject("Button");
        AddChild(btnDnArrow);
        AddChildWnd(btnDnArrow, wndRoot);
        btnDnArrow.Init(new UIElement(EUI.ID_SCROLL_DN,0,
                                    new Vector(0,0,0),
                                    new Vector(32,16,0),
                                    "Data/Menu/ramka_roz_dol.png",
                                    "Data/Menu/ramka2_roz_dol.png",
                                    "Data/Menu/ramka_roz_dol.png",
                                    "Data/Menu/ramka2_roz_dol.png",
                                    EButtonFlags.BTN_TYPE_PRESSBUTTON,
                                    ""),
                      module);
		btnScrollBar = (Button)CreateObject("Button");
		btnScrollBar.Init( new UIElement(0,0,
										 new Vector(0.0f,0.0f,0.0f),
										 new Vector(32.0f,16.0f,0.0f),
										 "Data/Menu/checkbox.png",
										 "Data/Menu/checkbox.png",
										 "Data/Menu/checkbox.png",
										 "Data/Menu/checkbox.png",
										 EButtonFlags.BTN_TYPE_PRESSBUTTON,
										 ""),
						   module);
		AddChild(btnScrollBar);
        AddChildWnd(btnScrollBar, wndRoot);
    }
    
    public void SetSize(Vector v)
    {
        super._SetSize(v);
        Vector arrowSize = btnUpArrow.GetSize();
        Vector pos = GetPos();
        Vector size = GetSize();
        btnUpArrow.SetRelativePos(new Vector(size.fX - arrowSize.fX, 0, 0));
        btnDnArrow.SetRelativePos(new Vector(size.fX - arrowSize.fX, size.fY - arrowSize.fY ,0));
		if (btnScrollBar != null)btnScrollBar.SetRelativePos(new Vector(size.fX - arrowSize.fX,arrowSize.fY,0.0f));
        //btnUpArrow.SetPos(new Vector(pos.fX + size.fX - arrowSize.fX, pos.fY, 0));
        //btnDnArrow.SetPos(new Vector(pos.fX + size.fX - arrowSize.fX, pos.fY + size.fY - arrowSize.fY ,0));
        if(bScrollVisible)
        {
            vClientSize.fX = v.fX - arrowSize.fX;
            vClientSize.fY = v.fY;
        }
        else
        {
            vClientSize.fX = v.fX;
            vClientSize.fY = v.fY;
        }
        SetCapacity(nCapacity);
    }

    void ShowScroll(boolean bShow)
    {
        super.ShowScroll(bShow);
        Vector v = GetSize();
        Vector arrowSize = btnUpArrow.GetSize();
        if(bScrollVisible)
        {
            vClientSize.fX = v.fX - arrowSize.fX;
            vClientSize.fY = v.fY;
        }
        else
        {
            vClientSize.fX = v.fX;
            vClientSize.fY = v.fY;
        }
        SetCapacity(nCapacity);
    }
}
