public class ContextMenu extends Window
{
    int nElemWidth = -1;
    
    int AddItem(Button btnItem)
    {
        AddChild((Sprite)btnItem);
        Vector vBtnSize = btnItem.GetSize();        
        if (nElemWidth != -1)
        {
            vBtnSize.fX = nElemWidth;
            btnItem.SetSize(vBtnSize);
        }
        Vector curSize = GetSize();
        Vector pos = GetPos();
        if (curSize.fX == 0.0) curSize.fX = vBtnSize.fX; 
        btnItem.SetRelativePos(new Vector(0, curSize.fY,0));
        SetSize(new Vector(curSize.fX, curSize.fY + vBtnSize.fY + 1,0));
        pos = btnItem.GetPos();
		btnItem.DisplayText(btnItem.sText);
		btnItem.SetTextPosFlags(ESpriteText.VERT_MIDDLE | ESpriteText.HORIZ_MIDDLE);
        AddChildWnd((Window)btnItem, wndRoot);
        return 1;
    }
    
    /**Ustala nowa szerokosc menu. Jesli nie ustalimy szerokosci, to kazdy z przyciskow
     * zachowa swoj rozmiar przy dodawaniu*/
    public void SetWidth(int nNewWidth)
    {
        if (nNewWidth > 0)
            nElemWidth = nNewWidth;
        else 
            return;
        int nItemCount = vChildWindows.size();
        if (nItemCount > 0)
        {
            Vector vElemSize = ((Button)vChildWindows.elementAt(0)).GetSize();
            vElemSize.fX = nElemWidth;
            for (int i = 0; i < vChildWindows.size(); i++)
            {
                ((Button)vChildWindows.elementAt(i)).SetSize(vElemSize);
            }
        }
    }
    
    void OnButton(Button btnSender)
    {
        wndParent.CallOnButton(btnSender);        
    }
    
    
}
