public class act_LockUnlock extends Action
{
    {sEditorComment = "Action of locking object specified by cTarget";}
    
    /** Obiekt do ktorego zostanie przeslana akcja */
    public iact_LockUnlock cTarget = null;//#
    public iact_LockUnlock[] aTargets = null;//#
    
    public EnumLockUnlock cType = new EnumLockUnlock(EnumLockUnlock._LOCK);//#;
    
    public void InvokeAction()
    {
        int nType = cType.GetValue();
        
        if(cTarget != null)
        {
            if( nType == EnumLockUnlock._LOCK) cTarget.Lock();
            if( nType == EnumLockUnlock._UNLOCK) cTarget.Unlock();
            if( nType == EnumLockUnlock._TOGGLE) cTarget.ToggleLockUnlock();
        }
        
        if(aTargets != null)
        {
            if( nType == EnumLockUnlock._LOCK)
                for(int i=0; i<aTargets.length; ++i)
                    if(aTargets[i] != null) aTargets[i].Lock();
        
            if( nType == EnumLockUnlock._UNLOCK)
                for(int i=0; i<aTargets.length; ++i)
                    if(aTargets[i] != null) aTargets[i].Unlock();
            
            if( nType == EnumLockUnlock._TOGGLE)
                for(int i=0; i<aTargets.length; ++i)
                    if(aTargets[i] != null) aTargets[i].ToggleLockUnlock();
        }
    }
}
