public class act_PlaySoundWait extends act_PlaySound
{
    {sEditorComment = "Plays specified sound and stops next actions";}
    
    void Invoke()
    {
        InvokeInternal();
    }

    /** Zmodyfikowana metoda InvokeInternal - jesli warunek nie jest prawdziwy
     *  wola nastepne akcje (bo w Invoke nie ma InvokeNext
     */
    void InvokeInternal()
    {
        // sprawdzamy warunek wykonania
        if( CheckCondition() )
        {
            // wykonanie akcji z uwzglednieniem przesuniecia
            CallMethodIn("InvokeAction", fDelay);
        }
        else 
            InvokeNext();
    }
    
    void InvokeAction()
    {
        if(sSoundFile != null)
        {
            PlaySoundInternal();
            
            float fInterval = GetWaveDuration(sSoundFile.toString());
            CallMethodIn("InvokeNext", fInterval);
        }
    }
}
