public class act_StartStop extends Action
{
    {sEditorComment = "Action of opening object specified by cTarget";}
    
    /** Typ akcji */
    public EnumStartStop cType = new EnumStartStop(EnumStartStop._TOGGLE);//#
    
    /** Obiekt do ktorego zostanie przeslana akcja */
    public iact_StartStop cTarget = null;//#
    
    public iact_StartStop[] aTargets = null;//#
    
    public void InvokeAction()
    {
        int nType = cType.GetValue();

        if(cTarget != null)
        {
            if( nType == EnumStartStop._START) cTarget.Start();
            if( nType == EnumStartStop._STOP) cTarget.Stop();
            if( nType == EnumStartStop._TOGGLE) cTarget.ToggleStartStop();
        }
        
        if(aTargets != null)
        {
            if( nType == EnumStartStop._START)
                for(int i=0; i<aTargets.length; ++i)
                    if(aTargets[i] != null) aTargets[i].Start();
            
            if( nType == EnumStartStop._STOP)
                for(int i=0; i<aTargets.length; ++i)
                    if(aTargets[i] != null) aTargets[i].Stop();
            
            if( nType == EnumStartStop._TOGGLE)
                for(int i=0; i<aTargets.length; ++i)
                    if(aTargets[i] != null) aTargets[i].ToggleStartStop();
        }
    }
}
